# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict


class EstimateAvailableFullDayTimeOffRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        EstimateAvailableFullDayTimeOffRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'date': 'date',
            'requested_duration_minutes': 'int'
        }

        self.attribute_map = {
            'date': 'date',
            'requested_duration_minutes': 'requestedDurationMinutes'
        }

        self._date = None
        self._requested_duration_minutes = None

    @property
    def date(self) -> date:
        """
        Gets the date of this EstimateAvailableFullDayTimeOffRequest.
        Date in yyyy-MM-dd format for full day request. Should be interpreted in the business unit's configured time zone. Dates are represented as an ISO-8601 string. For example: yyyy-MM-dd

        :return: The date of this EstimateAvailableFullDayTimeOffRequest.
        :rtype: date
        """
        return self._date

    @date.setter
    def date(self, date: date) -> None:
        """
        Sets the date of this EstimateAvailableFullDayTimeOffRequest.
        Date in yyyy-MM-dd format for full day request. Should be interpreted in the business unit's configured time zone. Dates are represented as an ISO-8601 string. For example: yyyy-MM-dd

        :param date: The date of this EstimateAvailableFullDayTimeOffRequest.
        :type: date
        """
        

        self._date = date

    @property
    def requested_duration_minutes(self) -> int:
        """
        Gets the requested_duration_minutes of this EstimateAvailableFullDayTimeOffRequest.
        A requested length of time off request in minutes. If the value is null, then the system will use activity code length setting

        :return: The requested_duration_minutes of this EstimateAvailableFullDayTimeOffRequest.
        :rtype: int
        """
        return self._requested_duration_minutes

    @requested_duration_minutes.setter
    def requested_duration_minutes(self, requested_duration_minutes: int) -> None:
        """
        Sets the requested_duration_minutes of this EstimateAvailableFullDayTimeOffRequest.
        A requested length of time off request in minutes. If the value is null, then the system will use activity code length setting

        :param requested_duration_minutes: The requested_duration_minutes of this EstimateAvailableFullDayTimeOffRequest.
        :type: int
        """
        

        self._requested_duration_minutes = requested_duration_minutes

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

