# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict


class SendMessageBody(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        SendMessageBody - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'message': 'str',
            'mentions': 'list[str]',
            'thread_id': 'str'
        }

        self.attribute_map = {
            'message': 'message',
            'mentions': 'mentions',
            'thread_id': 'threadId'
        }

        self._message = None
        self._mentions = None
        self._thread_id = None

    @property
    def message(self) -> str:
        """
        Gets the message of this SendMessageBody.
        The body of the message

        :return: The message of this SendMessageBody.
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message: str) -> None:
        """
        Sets the message of this SendMessageBody.
        The body of the message

        :param message: The message of this SendMessageBody.
        :type: str
        """
        

        self._message = message

    @property
    def mentions(self) -> List[str]:
        """
        Gets the mentions of this SendMessageBody.
        user ids to be notified

        :return: The mentions of this SendMessageBody.
        :rtype: list[str]
        """
        return self._mentions

    @mentions.setter
    def mentions(self, mentions: List[str]) -> None:
        """
        Sets the mentions of this SendMessageBody.
        user ids to be notified

        :param mentions: The mentions of this SendMessageBody.
        :type: list[str]
        """
        

        self._mentions = mentions

    @property
    def thread_id(self) -> str:
        """
        Gets the thread_id of this SendMessageBody.
        The thread id of the message

        :return: The thread_id of this SendMessageBody.
        :rtype: str
        """
        return self._thread_id

    @thread_id.setter
    def thread_id(self, thread_id: str) -> None:
        """
        Sets the thread_id of this SendMessageBody.
        The thread id of the message

        :param thread_id: The thread_id of this SendMessageBody.
        :type: str
        """
        

        self._thread_id = thread_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

